"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerlessApplicationRepository = void 0;
const CreateApplicationCommand_1 = require("./commands/CreateApplicationCommand");
const CreateApplicationVersionCommand_1 = require("./commands/CreateApplicationVersionCommand");
const CreateCloudFormationChangeSetCommand_1 = require("./commands/CreateCloudFormationChangeSetCommand");
const CreateCloudFormationTemplateCommand_1 = require("./commands/CreateCloudFormationTemplateCommand");
const DeleteApplicationCommand_1 = require("./commands/DeleteApplicationCommand");
const GetApplicationCommand_1 = require("./commands/GetApplicationCommand");
const GetApplicationPolicyCommand_1 = require("./commands/GetApplicationPolicyCommand");
const GetCloudFormationTemplateCommand_1 = require("./commands/GetCloudFormationTemplateCommand");
const ListApplicationDependenciesCommand_1 = require("./commands/ListApplicationDependenciesCommand");
const ListApplicationsCommand_1 = require("./commands/ListApplicationsCommand");
const ListApplicationVersionsCommand_1 = require("./commands/ListApplicationVersionsCommand");
const PutApplicationPolicyCommand_1 = require("./commands/PutApplicationPolicyCommand");
const UnshareApplicationCommand_1 = require("./commands/UnshareApplicationCommand");
const UpdateApplicationCommand_1 = require("./commands/UpdateApplicationCommand");
const ServerlessApplicationRepositoryClient_1 = require("./ServerlessApplicationRepositoryClient");
class ServerlessApplicationRepository extends ServerlessApplicationRepositoryClient_1.ServerlessApplicationRepositoryClient {
    createApplication(args, optionsOrCb, cb) {
        const command = new CreateApplicationCommand_1.CreateApplicationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    createApplicationVersion(args, optionsOrCb, cb) {
        const command = new CreateApplicationVersionCommand_1.CreateApplicationVersionCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    createCloudFormationChangeSet(args, optionsOrCb, cb) {
        const command = new CreateCloudFormationChangeSetCommand_1.CreateCloudFormationChangeSetCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    createCloudFormationTemplate(args, optionsOrCb, cb) {
        const command = new CreateCloudFormationTemplateCommand_1.CreateCloudFormationTemplateCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    deleteApplication(args, optionsOrCb, cb) {
        const command = new DeleteApplicationCommand_1.DeleteApplicationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getApplication(args, optionsOrCb, cb) {
        const command = new GetApplicationCommand_1.GetApplicationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getApplicationPolicy(args, optionsOrCb, cb) {
        const command = new GetApplicationPolicyCommand_1.GetApplicationPolicyCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getCloudFormationTemplate(args, optionsOrCb, cb) {
        const command = new GetCloudFormationTemplateCommand_1.GetCloudFormationTemplateCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    listApplicationDependencies(args, optionsOrCb, cb) {
        const command = new ListApplicationDependenciesCommand_1.ListApplicationDependenciesCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    listApplications(args, optionsOrCb, cb) {
        const command = new ListApplicationsCommand_1.ListApplicationsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    listApplicationVersions(args, optionsOrCb, cb) {
        const command = new ListApplicationVersionsCommand_1.ListApplicationVersionsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    putApplicationPolicy(args, optionsOrCb, cb) {
        const command = new PutApplicationPolicyCommand_1.PutApplicationPolicyCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    unshareApplication(args, optionsOrCb, cb) {
        const command = new UnshareApplicationCommand_1.UnshareApplicationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    updateApplication(args, optionsOrCb, cb) {
        const command = new UpdateApplicationCommand_1.UpdateApplicationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
}
exports.ServerlessApplicationRepository = ServerlessApplicationRepository;
