"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateApplicationResponse = exports.UpdateApplicationRequest = exports.UnshareApplicationRequest = exports.PutApplicationPolicyResponse = exports.PutApplicationPolicyRequest = exports.ListApplicationVersionsResponse = exports.ListApplicationVersionsRequest = exports.ListApplicationsResponse = exports.ListApplicationsRequest = exports.ListApplicationDependenciesResponse = exports.ListApplicationDependenciesRequest = exports.GetCloudFormationTemplateResponse = exports.GetCloudFormationTemplateRequest = exports.GetApplicationPolicyResponse = exports.GetApplicationPolicyRequest = exports.GetApplicationResponse = exports.GetApplicationRequest = exports.DeleteApplicationRequest = exports.NotFoundException = exports.CreateCloudFormationTemplateResponse = exports.Status = exports.CreateCloudFormationTemplateRequest = exports.CreateCloudFormationChangeSetResponse = exports.CreateCloudFormationChangeSetRequest = exports.RollbackConfiguration = exports.CreateApplicationVersionResponse = exports.CreateApplicationVersionRequest = exports.TooManyRequestsException = exports.InternalServerErrorException = exports.ForbiddenException = exports.CreateApplicationResponse = exports.Version = exports.CreateApplicationRequest = exports.ConflictException = exports.BadRequestException = exports.VersionSummary = exports.Tag = exports.RollbackTrigger = exports.ParameterValue = exports.ParameterDefinition = exports.Capability = exports.ApplicationSummary = exports.ApplicationPolicyStatement = exports.ApplicationDependencySummary = void 0;
const ServerlessApplicationRepositoryServiceException_1 = require("./ServerlessApplicationRepositoryServiceException");
var ApplicationDependencySummary;
(function (ApplicationDependencySummary) {
    ApplicationDependencySummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ApplicationDependencySummary = exports.ApplicationDependencySummary || (exports.ApplicationDependencySummary = {}));
var ApplicationPolicyStatement;
(function (ApplicationPolicyStatement) {
    ApplicationPolicyStatement.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ApplicationPolicyStatement = exports.ApplicationPolicyStatement || (exports.ApplicationPolicyStatement = {}));
var ApplicationSummary;
(function (ApplicationSummary) {
    ApplicationSummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ApplicationSummary = exports.ApplicationSummary || (exports.ApplicationSummary = {}));
var Capability;
(function (Capability) {
    Capability["CAPABILITY_AUTO_EXPAND"] = "CAPABILITY_AUTO_EXPAND";
    Capability["CAPABILITY_IAM"] = "CAPABILITY_IAM";
    Capability["CAPABILITY_NAMED_IAM"] = "CAPABILITY_NAMED_IAM";
    Capability["CAPABILITY_RESOURCE_POLICY"] = "CAPABILITY_RESOURCE_POLICY";
})(Capability = exports.Capability || (exports.Capability = {}));
var ParameterDefinition;
(function (ParameterDefinition) {
    ParameterDefinition.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ParameterDefinition = exports.ParameterDefinition || (exports.ParameterDefinition = {}));
var ParameterValue;
(function (ParameterValue) {
    ParameterValue.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ParameterValue = exports.ParameterValue || (exports.ParameterValue = {}));
var RollbackTrigger;
(function (RollbackTrigger) {
    RollbackTrigger.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RollbackTrigger = exports.RollbackTrigger || (exports.RollbackTrigger = {}));
var Tag;
(function (Tag) {
    Tag.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Tag = exports.Tag || (exports.Tag = {}));
var VersionSummary;
(function (VersionSummary) {
    VersionSummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(VersionSummary = exports.VersionSummary || (exports.VersionSummary = {}));
class BadRequestException extends ServerlessApplicationRepositoryServiceException_1.ServerlessApplicationRepositoryServiceException {
    constructor(opts) {
        super({
            name: "BadRequestException",
            $fault: "client",
            ...opts,
        });
        this.name = "BadRequestException";
        this.$fault = "client";
        Object.setPrototypeOf(this, BadRequestException.prototype);
        this.ErrorCode = opts.ErrorCode;
        this.Message = opts.Message;
    }
}
exports.BadRequestException = BadRequestException;
class ConflictException extends ServerlessApplicationRepositoryServiceException_1.ServerlessApplicationRepositoryServiceException {
    constructor(opts) {
        super({
            name: "ConflictException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConflictException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConflictException.prototype);
        this.ErrorCode = opts.ErrorCode;
        this.Message = opts.Message;
    }
}
exports.ConflictException = ConflictException;
var CreateApplicationRequest;
(function (CreateApplicationRequest) {
    CreateApplicationRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateApplicationRequest = exports.CreateApplicationRequest || (exports.CreateApplicationRequest = {}));
var Version;
(function (Version) {
    Version.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Version = exports.Version || (exports.Version = {}));
var CreateApplicationResponse;
(function (CreateApplicationResponse) {
    CreateApplicationResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateApplicationResponse = exports.CreateApplicationResponse || (exports.CreateApplicationResponse = {}));
class ForbiddenException extends ServerlessApplicationRepositoryServiceException_1.ServerlessApplicationRepositoryServiceException {
    constructor(opts) {
        super({
            name: "ForbiddenException",
            $fault: "client",
            ...opts,
        });
        this.name = "ForbiddenException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ForbiddenException.prototype);
        this.ErrorCode = opts.ErrorCode;
        this.Message = opts.Message;
    }
}
exports.ForbiddenException = ForbiddenException;
class InternalServerErrorException extends ServerlessApplicationRepositoryServiceException_1.ServerlessApplicationRepositoryServiceException {
    constructor(opts) {
        super({
            name: "InternalServerErrorException",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalServerErrorException";
        this.$fault = "server";
        Object.setPrototypeOf(this, InternalServerErrorException.prototype);
        this.ErrorCode = opts.ErrorCode;
        this.Message = opts.Message;
    }
}
exports.InternalServerErrorException = InternalServerErrorException;
class TooManyRequestsException extends ServerlessApplicationRepositoryServiceException_1.ServerlessApplicationRepositoryServiceException {
    constructor(opts) {
        super({
            name: "TooManyRequestsException",
            $fault: "client",
            ...opts,
        });
        this.name = "TooManyRequestsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, TooManyRequestsException.prototype);
        this.ErrorCode = opts.ErrorCode;
        this.Message = opts.Message;
    }
}
exports.TooManyRequestsException = TooManyRequestsException;
var CreateApplicationVersionRequest;
(function (CreateApplicationVersionRequest) {
    CreateApplicationVersionRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateApplicationVersionRequest = exports.CreateApplicationVersionRequest || (exports.CreateApplicationVersionRequest = {}));
var CreateApplicationVersionResponse;
(function (CreateApplicationVersionResponse) {
    CreateApplicationVersionResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateApplicationVersionResponse = exports.CreateApplicationVersionResponse || (exports.CreateApplicationVersionResponse = {}));
var RollbackConfiguration;
(function (RollbackConfiguration) {
    RollbackConfiguration.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RollbackConfiguration = exports.RollbackConfiguration || (exports.RollbackConfiguration = {}));
var CreateCloudFormationChangeSetRequest;
(function (CreateCloudFormationChangeSetRequest) {
    CreateCloudFormationChangeSetRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateCloudFormationChangeSetRequest = exports.CreateCloudFormationChangeSetRequest || (exports.CreateCloudFormationChangeSetRequest = {}));
var CreateCloudFormationChangeSetResponse;
(function (CreateCloudFormationChangeSetResponse) {
    CreateCloudFormationChangeSetResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateCloudFormationChangeSetResponse = exports.CreateCloudFormationChangeSetResponse || (exports.CreateCloudFormationChangeSetResponse = {}));
var CreateCloudFormationTemplateRequest;
(function (CreateCloudFormationTemplateRequest) {
    CreateCloudFormationTemplateRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateCloudFormationTemplateRequest = exports.CreateCloudFormationTemplateRequest || (exports.CreateCloudFormationTemplateRequest = {}));
var Status;
(function (Status) {
    Status["ACTIVE"] = "ACTIVE";
    Status["EXPIRED"] = "EXPIRED";
    Status["PREPARING"] = "PREPARING";
})(Status = exports.Status || (exports.Status = {}));
var CreateCloudFormationTemplateResponse;
(function (CreateCloudFormationTemplateResponse) {
    CreateCloudFormationTemplateResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateCloudFormationTemplateResponse = exports.CreateCloudFormationTemplateResponse || (exports.CreateCloudFormationTemplateResponse = {}));
class NotFoundException extends ServerlessApplicationRepositoryServiceException_1.ServerlessApplicationRepositoryServiceException {
    constructor(opts) {
        super({
            name: "NotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "NotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, NotFoundException.prototype);
        this.ErrorCode = opts.ErrorCode;
        this.Message = opts.Message;
    }
}
exports.NotFoundException = NotFoundException;
var DeleteApplicationRequest;
(function (DeleteApplicationRequest) {
    DeleteApplicationRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteApplicationRequest = exports.DeleteApplicationRequest || (exports.DeleteApplicationRequest = {}));
var GetApplicationRequest;
(function (GetApplicationRequest) {
    GetApplicationRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetApplicationRequest = exports.GetApplicationRequest || (exports.GetApplicationRequest = {}));
var GetApplicationResponse;
(function (GetApplicationResponse) {
    GetApplicationResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetApplicationResponse = exports.GetApplicationResponse || (exports.GetApplicationResponse = {}));
var GetApplicationPolicyRequest;
(function (GetApplicationPolicyRequest) {
    GetApplicationPolicyRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetApplicationPolicyRequest = exports.GetApplicationPolicyRequest || (exports.GetApplicationPolicyRequest = {}));
var GetApplicationPolicyResponse;
(function (GetApplicationPolicyResponse) {
    GetApplicationPolicyResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetApplicationPolicyResponse = exports.GetApplicationPolicyResponse || (exports.GetApplicationPolicyResponse = {}));
var GetCloudFormationTemplateRequest;
(function (GetCloudFormationTemplateRequest) {
    GetCloudFormationTemplateRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetCloudFormationTemplateRequest = exports.GetCloudFormationTemplateRequest || (exports.GetCloudFormationTemplateRequest = {}));
var GetCloudFormationTemplateResponse;
(function (GetCloudFormationTemplateResponse) {
    GetCloudFormationTemplateResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetCloudFormationTemplateResponse = exports.GetCloudFormationTemplateResponse || (exports.GetCloudFormationTemplateResponse = {}));
var ListApplicationDependenciesRequest;
(function (ListApplicationDependenciesRequest) {
    ListApplicationDependenciesRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListApplicationDependenciesRequest = exports.ListApplicationDependenciesRequest || (exports.ListApplicationDependenciesRequest = {}));
var ListApplicationDependenciesResponse;
(function (ListApplicationDependenciesResponse) {
    ListApplicationDependenciesResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListApplicationDependenciesResponse = exports.ListApplicationDependenciesResponse || (exports.ListApplicationDependenciesResponse = {}));
var ListApplicationsRequest;
(function (ListApplicationsRequest) {
    ListApplicationsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListApplicationsRequest = exports.ListApplicationsRequest || (exports.ListApplicationsRequest = {}));
var ListApplicationsResponse;
(function (ListApplicationsResponse) {
    ListApplicationsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListApplicationsResponse = exports.ListApplicationsResponse || (exports.ListApplicationsResponse = {}));
var ListApplicationVersionsRequest;
(function (ListApplicationVersionsRequest) {
    ListApplicationVersionsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListApplicationVersionsRequest = exports.ListApplicationVersionsRequest || (exports.ListApplicationVersionsRequest = {}));
var ListApplicationVersionsResponse;
(function (ListApplicationVersionsResponse) {
    ListApplicationVersionsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListApplicationVersionsResponse = exports.ListApplicationVersionsResponse || (exports.ListApplicationVersionsResponse = {}));
var PutApplicationPolicyRequest;
(function (PutApplicationPolicyRequest) {
    PutApplicationPolicyRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(PutApplicationPolicyRequest = exports.PutApplicationPolicyRequest || (exports.PutApplicationPolicyRequest = {}));
var PutApplicationPolicyResponse;
(function (PutApplicationPolicyResponse) {
    PutApplicationPolicyResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(PutApplicationPolicyResponse = exports.PutApplicationPolicyResponse || (exports.PutApplicationPolicyResponse = {}));
var UnshareApplicationRequest;
(function (UnshareApplicationRequest) {
    UnshareApplicationRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UnshareApplicationRequest = exports.UnshareApplicationRequest || (exports.UnshareApplicationRequest = {}));
var UpdateApplicationRequest;
(function (UpdateApplicationRequest) {
    UpdateApplicationRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateApplicationRequest = exports.UpdateApplicationRequest || (exports.UpdateApplicationRequest = {}));
var UpdateApplicationResponse;
(function (UpdateApplicationResponse) {
    UpdateApplicationResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateApplicationResponse = exports.UpdateApplicationResponse || (exports.UpdateApplicationResponse = {}));
