import { __extends } from "tslib";
import { CreateApplicationCommand, } from "./commands/CreateApplicationCommand";
import { CreateApplicationVersionCommand, } from "./commands/CreateApplicationVersionCommand";
import { CreateCloudFormationChangeSetCommand, } from "./commands/CreateCloudFormationChangeSetCommand";
import { CreateCloudFormationTemplateCommand, } from "./commands/CreateCloudFormationTemplateCommand";
import { DeleteApplicationCommand, } from "./commands/DeleteApplicationCommand";
import { GetApplicationCommand, } from "./commands/GetApplicationCommand";
import { GetApplicationPolicyCommand, } from "./commands/GetApplicationPolicyCommand";
import { GetCloudFormationTemplateCommand, } from "./commands/GetCloudFormationTemplateCommand";
import { ListApplicationDependenciesCommand, } from "./commands/ListApplicationDependenciesCommand";
import { ListApplicationsCommand, } from "./commands/ListApplicationsCommand";
import { ListApplicationVersionsCommand, } from "./commands/ListApplicationVersionsCommand";
import { PutApplicationPolicyCommand, } from "./commands/PutApplicationPolicyCommand";
import { UnshareApplicationCommand, } from "./commands/UnshareApplicationCommand";
import { UpdateApplicationCommand, } from "./commands/UpdateApplicationCommand";
import { ServerlessApplicationRepositoryClient } from "./ServerlessApplicationRepositoryClient";
var ServerlessApplicationRepository = (function (_super) {
    __extends(ServerlessApplicationRepository, _super);
    function ServerlessApplicationRepository() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ServerlessApplicationRepository.prototype.createApplication = function (args, optionsOrCb, cb) {
        var command = new CreateApplicationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    ServerlessApplicationRepository.prototype.createApplicationVersion = function (args, optionsOrCb, cb) {
        var command = new CreateApplicationVersionCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    ServerlessApplicationRepository.prototype.createCloudFormationChangeSet = function (args, optionsOrCb, cb) {
        var command = new CreateCloudFormationChangeSetCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    ServerlessApplicationRepository.prototype.createCloudFormationTemplate = function (args, optionsOrCb, cb) {
        var command = new CreateCloudFormationTemplateCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    ServerlessApplicationRepository.prototype.deleteApplication = function (args, optionsOrCb, cb) {
        var command = new DeleteApplicationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    ServerlessApplicationRepository.prototype.getApplication = function (args, optionsOrCb, cb) {
        var command = new GetApplicationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    ServerlessApplicationRepository.prototype.getApplicationPolicy = function (args, optionsOrCb, cb) {
        var command = new GetApplicationPolicyCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    ServerlessApplicationRepository.prototype.getCloudFormationTemplate = function (args, optionsOrCb, cb) {
        var command = new GetCloudFormationTemplateCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    ServerlessApplicationRepository.prototype.listApplicationDependencies = function (args, optionsOrCb, cb) {
        var command = new ListApplicationDependenciesCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    ServerlessApplicationRepository.prototype.listApplications = function (args, optionsOrCb, cb) {
        var command = new ListApplicationsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    ServerlessApplicationRepository.prototype.listApplicationVersions = function (args, optionsOrCb, cb) {
        var command = new ListApplicationVersionsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    ServerlessApplicationRepository.prototype.putApplicationPolicy = function (args, optionsOrCb, cb) {
        var command = new PutApplicationPolicyCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    ServerlessApplicationRepository.prototype.unshareApplication = function (args, optionsOrCb, cb) {
        var command = new UnshareApplicationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    ServerlessApplicationRepository.prototype.updateApplication = function (args, optionsOrCb, cb) {
        var command = new UpdateApplicationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error("Expect http options but get ".concat(typeof optionsOrCb));
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    };
    return ServerlessApplicationRepository;
}(ServerlessApplicationRepositoryClient));
export { ServerlessApplicationRepository };
