import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateApplicationVersionRequest, CreateApplicationVersionResponse } from "../models/models_0";
import { deserializeAws_restJson1CreateApplicationVersionCommand, serializeAws_restJson1CreateApplicationVersionCommand, } from "../protocols/Aws_restJson1";
var CreateApplicationVersionCommand = (function (_super) {
    __extends(CreateApplicationVersionCommand, _super);
    function CreateApplicationVersionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateApplicationVersionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ServerlessApplicationRepositoryClient";
        var commandName = "CreateApplicationVersionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateApplicationVersionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateApplicationVersionResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateApplicationVersionCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1CreateApplicationVersionCommand(input, context);
    };
    CreateApplicationVersionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1CreateApplicationVersionCommand(output, context);
    };
    return CreateApplicationVersionCommand;
}($Command));
export { CreateApplicationVersionCommand };
