import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateCloudFormationChangeSetRequest, CreateCloudFormationChangeSetResponse } from "../models/models_0";
import { deserializeAws_restJson1CreateCloudFormationChangeSetCommand, serializeAws_restJson1CreateCloudFormationChangeSetCommand, } from "../protocols/Aws_restJson1";
var CreateCloudFormationChangeSetCommand = (function (_super) {
    __extends(CreateCloudFormationChangeSetCommand, _super);
    function CreateCloudFormationChangeSetCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateCloudFormationChangeSetCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ServerlessApplicationRepositoryClient";
        var commandName = "CreateCloudFormationChangeSetCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateCloudFormationChangeSetRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateCloudFormationChangeSetResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateCloudFormationChangeSetCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1CreateCloudFormationChangeSetCommand(input, context);
    };
    CreateCloudFormationChangeSetCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1CreateCloudFormationChangeSetCommand(output, context);
    };
    return CreateCloudFormationChangeSetCommand;
}($Command));
export { CreateCloudFormationChangeSetCommand };
