import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateCloudFormationTemplateRequest, CreateCloudFormationTemplateResponse } from "../models/models_0";
import { deserializeAws_restJson1CreateCloudFormationTemplateCommand, serializeAws_restJson1CreateCloudFormationTemplateCommand, } from "../protocols/Aws_restJson1";
var CreateCloudFormationTemplateCommand = (function (_super) {
    __extends(CreateCloudFormationTemplateCommand, _super);
    function CreateCloudFormationTemplateCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateCloudFormationTemplateCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ServerlessApplicationRepositoryClient";
        var commandName = "CreateCloudFormationTemplateCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateCloudFormationTemplateRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateCloudFormationTemplateResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateCloudFormationTemplateCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1CreateCloudFormationTemplateCommand(input, context);
    };
    CreateCloudFormationTemplateCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1CreateCloudFormationTemplateCommand(output, context);
    };
    return CreateCloudFormationTemplateCommand;
}($Command));
export { CreateCloudFormationTemplateCommand };
