import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetApplicationPolicyRequest, GetApplicationPolicyResponse } from "../models/models_0";
import { deserializeAws_restJson1GetApplicationPolicyCommand, serializeAws_restJson1GetApplicationPolicyCommand, } from "../protocols/Aws_restJson1";
var GetApplicationPolicyCommand = (function (_super) {
    __extends(GetApplicationPolicyCommand, _super);
    function GetApplicationPolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetApplicationPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ServerlessApplicationRepositoryClient";
        var commandName = "GetApplicationPolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetApplicationPolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetApplicationPolicyResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetApplicationPolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1GetApplicationPolicyCommand(input, context);
    };
    GetApplicationPolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1GetApplicationPolicyCommand(output, context);
    };
    return GetApplicationPolicyCommand;
}($Command));
export { GetApplicationPolicyCommand };
