import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetCloudFormationTemplateRequest, GetCloudFormationTemplateResponse } from "../models/models_0";
import { deserializeAws_restJson1GetCloudFormationTemplateCommand, serializeAws_restJson1GetCloudFormationTemplateCommand, } from "../protocols/Aws_restJson1";
var GetCloudFormationTemplateCommand = (function (_super) {
    __extends(GetCloudFormationTemplateCommand, _super);
    function GetCloudFormationTemplateCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetCloudFormationTemplateCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ServerlessApplicationRepositoryClient";
        var commandName = "GetCloudFormationTemplateCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetCloudFormationTemplateRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetCloudFormationTemplateResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetCloudFormationTemplateCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1GetCloudFormationTemplateCommand(input, context);
    };
    GetCloudFormationTemplateCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1GetCloudFormationTemplateCommand(output, context);
    };
    return GetCloudFormationTemplateCommand;
}($Command));
export { GetCloudFormationTemplateCommand };
