import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListApplicationDependenciesRequest, ListApplicationDependenciesResponse } from "../models/models_0";
import { deserializeAws_restJson1ListApplicationDependenciesCommand, serializeAws_restJson1ListApplicationDependenciesCommand, } from "../protocols/Aws_restJson1";
var ListApplicationDependenciesCommand = (function (_super) {
    __extends(ListApplicationDependenciesCommand, _super);
    function ListApplicationDependenciesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListApplicationDependenciesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ServerlessApplicationRepositoryClient";
        var commandName = "ListApplicationDependenciesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListApplicationDependenciesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListApplicationDependenciesResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListApplicationDependenciesCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListApplicationDependenciesCommand(input, context);
    };
    ListApplicationDependenciesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListApplicationDependenciesCommand(output, context);
    };
    return ListApplicationDependenciesCommand;
}($Command));
export { ListApplicationDependenciesCommand };
