import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListApplicationVersionsRequest, ListApplicationVersionsResponse } from "../models/models_0";
import { deserializeAws_restJson1ListApplicationVersionsCommand, serializeAws_restJson1ListApplicationVersionsCommand, } from "../protocols/Aws_restJson1";
var ListApplicationVersionsCommand = (function (_super) {
    __extends(ListApplicationVersionsCommand, _super);
    function ListApplicationVersionsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListApplicationVersionsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ServerlessApplicationRepositoryClient";
        var commandName = "ListApplicationVersionsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListApplicationVersionsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListApplicationVersionsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListApplicationVersionsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListApplicationVersionsCommand(input, context);
    };
    ListApplicationVersionsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListApplicationVersionsCommand(output, context);
    };
    return ListApplicationVersionsCommand;
}($Command));
export { ListApplicationVersionsCommand };
