import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PutApplicationPolicyRequest, PutApplicationPolicyResponse } from "../models/models_0";
import { deserializeAws_restJson1PutApplicationPolicyCommand, serializeAws_restJson1PutApplicationPolicyCommand, } from "../protocols/Aws_restJson1";
var PutApplicationPolicyCommand = (function (_super) {
    __extends(PutApplicationPolicyCommand, _super);
    function PutApplicationPolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PutApplicationPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ServerlessApplicationRepositoryClient";
        var commandName = "PutApplicationPolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PutApplicationPolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: PutApplicationPolicyResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PutApplicationPolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1PutApplicationPolicyCommand(input, context);
    };
    PutApplicationPolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1PutApplicationPolicyCommand(output, context);
    };
    return PutApplicationPolicyCommand;
}($Command));
export { PutApplicationPolicyCommand };
