import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UnshareApplicationRequest } from "../models/models_0";
import { deserializeAws_restJson1UnshareApplicationCommand, serializeAws_restJson1UnshareApplicationCommand, } from "../protocols/Aws_restJson1";
var UnshareApplicationCommand = (function (_super) {
    __extends(UnshareApplicationCommand, _super);
    function UnshareApplicationCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UnshareApplicationCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ServerlessApplicationRepositoryClient";
        var commandName = "UnshareApplicationCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UnshareApplicationRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UnshareApplicationCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1UnshareApplicationCommand(input, context);
    };
    UnshareApplicationCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1UnshareApplicationCommand(output, context);
    };
    return UnshareApplicationCommand;
}($Command));
export { UnshareApplicationCommand };
