import { EndpointsInputConfig, EndpointsResolvedConfig, RegionInputConfig, RegionResolvedConfig } from "@aws-sdk/config-resolver";
import { HostHeaderInputConfig, HostHeaderResolvedConfig } from "@aws-sdk/middleware-host-header";
import { RetryInputConfig, RetryResolvedConfig } from "@aws-sdk/middleware-retry";
import { AwsAuthInputConfig, AwsAuthResolvedConfig } from "@aws-sdk/middleware-signing";
import { UserAgentInputConfig, UserAgentResolvedConfig } from "@aws-sdk/middleware-user-agent";
import { HttpHandler as __HttpHandler } from "@aws-sdk/protocol-http";
import { Client as __Client, DefaultsMode, SmithyConfiguration as __SmithyConfiguration, SmithyResolvedConfiguration as __SmithyResolvedConfiguration } from "@aws-sdk/smithy-client";
import { BodyLengthCalculator as __BodyLengthCalculator, Credentials as __Credentials, Decoder as __Decoder, Encoder as __Encoder, HashConstructor as __HashConstructor, HttpHandlerOptions as __HttpHandlerOptions, Logger as __Logger, Provider as __Provider, Provider, RegionInfoProvider, StreamCollector as __StreamCollector, UrlParser as __UrlParser, UserAgent as __UserAgent } from "@aws-sdk/types";
import { CreateApplicationCommandInput, CreateApplicationCommandOutput } from "./commands/CreateApplicationCommand";
import { CreateApplicationVersionCommandInput, CreateApplicationVersionCommandOutput } from "./commands/CreateApplicationVersionCommand";
import { CreateCloudFormationChangeSetCommandInput, CreateCloudFormationChangeSetCommandOutput } from "./commands/CreateCloudFormationChangeSetCommand";
import { CreateCloudFormationTemplateCommandInput, CreateCloudFormationTemplateCommandOutput } from "./commands/CreateCloudFormationTemplateCommand";
import { DeleteApplicationCommandInput, DeleteApplicationCommandOutput } from "./commands/DeleteApplicationCommand";
import { GetApplicationCommandInput, GetApplicationCommandOutput } from "./commands/GetApplicationCommand";
import { GetApplicationPolicyCommandInput, GetApplicationPolicyCommandOutput } from "./commands/GetApplicationPolicyCommand";
import { GetCloudFormationTemplateCommandInput, GetCloudFormationTemplateCommandOutput } from "./commands/GetCloudFormationTemplateCommand";
import { ListApplicationDependenciesCommandInput, ListApplicationDependenciesCommandOutput } from "./commands/ListApplicationDependenciesCommand";
import { ListApplicationsCommandInput, ListApplicationsCommandOutput } from "./commands/ListApplicationsCommand";
import { ListApplicationVersionsCommandInput, ListApplicationVersionsCommandOutput } from "./commands/ListApplicationVersionsCommand";
import { PutApplicationPolicyCommandInput, PutApplicationPolicyCommandOutput } from "./commands/PutApplicationPolicyCommand";
import { UnshareApplicationCommandInput, UnshareApplicationCommandOutput } from "./commands/UnshareApplicationCommand";
import { UpdateApplicationCommandInput, UpdateApplicationCommandOutput } from "./commands/UpdateApplicationCommand";
export declare type ServiceInputTypes = CreateApplicationCommandInput | CreateApplicationVersionCommandInput | CreateCloudFormationChangeSetCommandInput | CreateCloudFormationTemplateCommandInput | DeleteApplicationCommandInput | GetApplicationCommandInput | GetApplicationPolicyCommandInput | GetCloudFormationTemplateCommandInput | ListApplicationDependenciesCommandInput | ListApplicationVersionsCommandInput | ListApplicationsCommandInput | PutApplicationPolicyCommandInput | UnshareApplicationCommandInput | UpdateApplicationCommandInput;
export declare type ServiceOutputTypes = CreateApplicationCommandOutput | CreateApplicationVersionCommandOutput | CreateCloudFormationChangeSetCommandOutput | CreateCloudFormationTemplateCommandOutput | DeleteApplicationCommandOutput | GetApplicationCommandOutput | GetApplicationPolicyCommandOutput | GetCloudFormationTemplateCommandOutput | ListApplicationDependenciesCommandOutput | ListApplicationVersionsCommandOutput | ListApplicationsCommandOutput | PutApplicationPolicyCommandOutput | UnshareApplicationCommandOutput | UpdateApplicationCommandOutput;
export interface ClientDefaults extends Partial<__SmithyResolvedConfiguration<__HttpHandlerOptions>> {
    
    requestHandler?: __HttpHandler;
    
    sha256?: __HashConstructor;
    
    urlParser?: __UrlParser;
    
    bodyLengthChecker?: __BodyLengthCalculator;
    
    streamCollector?: __StreamCollector;
    
    base64Decoder?: __Decoder;
    
    base64Encoder?: __Encoder;
    
    utf8Decoder?: __Decoder;
    
    utf8Encoder?: __Encoder;
    
    runtime?: string;
    
    disableHostPrefix?: boolean;
    
    maxAttempts?: number | __Provider<number>;
    
    retryMode?: string | __Provider<string>;
    
    logger?: __Logger;
    
    useDualstackEndpoint?: boolean | __Provider<boolean>;
    
    useFipsEndpoint?: boolean | __Provider<boolean>;
    
    serviceId?: string;
    
    region?: string | __Provider<string>;
    
    credentialDefaultProvider?: (input: any) => __Provider<__Credentials>;
    
    regionInfoProvider?: RegionInfoProvider;
    
    defaultUserAgentProvider?: Provider<__UserAgent>;
    
    defaultsMode?: DefaultsMode | Provider<DefaultsMode>;
}
declare type ServerlessApplicationRepositoryClientConfigType = Partial<__SmithyConfiguration<__HttpHandlerOptions>> & ClientDefaults & RegionInputConfig & EndpointsInputConfig & RetryInputConfig & HostHeaderInputConfig & AwsAuthInputConfig & UserAgentInputConfig;

export interface ServerlessApplicationRepositoryClientConfig extends ServerlessApplicationRepositoryClientConfigType {
}
declare type ServerlessApplicationRepositoryClientResolvedConfigType = __SmithyResolvedConfiguration<__HttpHandlerOptions> & Required<ClientDefaults> & RegionResolvedConfig & EndpointsResolvedConfig & RetryResolvedConfig & HostHeaderResolvedConfig & AwsAuthResolvedConfig & UserAgentResolvedConfig;

export interface ServerlessApplicationRepositoryClientResolvedConfig extends ServerlessApplicationRepositoryClientResolvedConfigType {
}

export declare class ServerlessApplicationRepositoryClient extends __Client<__HttpHandlerOptions, ServiceInputTypes, ServiceOutputTypes, ServerlessApplicationRepositoryClientResolvedConfig> {
    
    readonly config: ServerlessApplicationRepositoryClientResolvedConfig;
    constructor(configuration: ServerlessApplicationRepositoryClientConfig);
    
    destroy(): void;
}
export {};
