import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CreateCloudFormationChangeSetRequest, CreateCloudFormationChangeSetResponse } from "../models/models_0";
import { ServerlessApplicationRepositoryClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ServerlessApplicationRepositoryClient";
export interface CreateCloudFormationChangeSetCommandInput extends CreateCloudFormationChangeSetRequest {
}
export interface CreateCloudFormationChangeSetCommandOutput extends CreateCloudFormationChangeSetResponse, __MetadataBearer {
}

export declare class CreateCloudFormationChangeSetCommand extends $Command<CreateCloudFormationChangeSetCommandInput, CreateCloudFormationChangeSetCommandOutput, ServerlessApplicationRepositoryClientResolvedConfig> {
    readonly input: CreateCloudFormationChangeSetCommandInput;
    constructor(input: CreateCloudFormationChangeSetCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ServerlessApplicationRepositoryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateCloudFormationChangeSetCommandInput, CreateCloudFormationChangeSetCommandOutput>;
    private serialize;
    private deserialize;
}
