import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CreateCloudFormationTemplateRequest, CreateCloudFormationTemplateResponse } from "../models/models_0";
import { ServerlessApplicationRepositoryClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ServerlessApplicationRepositoryClient";
export interface CreateCloudFormationTemplateCommandInput extends CreateCloudFormationTemplateRequest {
}
export interface CreateCloudFormationTemplateCommandOutput extends CreateCloudFormationTemplateResponse, __MetadataBearer {
}

export declare class CreateCloudFormationTemplateCommand extends $Command<CreateCloudFormationTemplateCommandInput, CreateCloudFormationTemplateCommandOutput, ServerlessApplicationRepositoryClientResolvedConfig> {
    readonly input: CreateCloudFormationTemplateCommandInput;
    constructor(input: CreateCloudFormationTemplateCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ServerlessApplicationRepositoryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateCloudFormationTemplateCommandInput, CreateCloudFormationTemplateCommandOutput>;
    private serialize;
    private deserialize;
}
