import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { GetApplicationPolicyRequest, GetApplicationPolicyResponse } from "../models/models_0";
import { ServerlessApplicationRepositoryClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ServerlessApplicationRepositoryClient";
export interface GetApplicationPolicyCommandInput extends GetApplicationPolicyRequest {
}
export interface GetApplicationPolicyCommandOutput extends GetApplicationPolicyResponse, __MetadataBearer {
}

export declare class GetApplicationPolicyCommand extends $Command<GetApplicationPolicyCommandInput, GetApplicationPolicyCommandOutput, ServerlessApplicationRepositoryClientResolvedConfig> {
    readonly input: GetApplicationPolicyCommandInput;
    constructor(input: GetApplicationPolicyCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ServerlessApplicationRepositoryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetApplicationPolicyCommandInput, GetApplicationPolicyCommandOutput>;
    private serialize;
    private deserialize;
}
