import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { GetCloudFormationTemplateRequest, GetCloudFormationTemplateResponse } from "../models/models_0";
import { ServerlessApplicationRepositoryClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ServerlessApplicationRepositoryClient";
export interface GetCloudFormationTemplateCommandInput extends GetCloudFormationTemplateRequest {
}
export interface GetCloudFormationTemplateCommandOutput extends GetCloudFormationTemplateResponse, __MetadataBearer {
}

export declare class GetCloudFormationTemplateCommand extends $Command<GetCloudFormationTemplateCommandInput, GetCloudFormationTemplateCommandOutput, ServerlessApplicationRepositoryClientResolvedConfig> {
    readonly input: GetCloudFormationTemplateCommandInput;
    constructor(input: GetCloudFormationTemplateCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ServerlessApplicationRepositoryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetCloudFormationTemplateCommandInput, GetCloudFormationTemplateCommandOutput>;
    private serialize;
    private deserialize;
}
