import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ListApplicationDependenciesRequest, ListApplicationDependenciesResponse } from "../models/models_0";
import { ServerlessApplicationRepositoryClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ServerlessApplicationRepositoryClient";
export interface ListApplicationDependenciesCommandInput extends ListApplicationDependenciesRequest {
}
export interface ListApplicationDependenciesCommandOutput extends ListApplicationDependenciesResponse, __MetadataBearer {
}

export declare class ListApplicationDependenciesCommand extends $Command<ListApplicationDependenciesCommandInput, ListApplicationDependenciesCommandOutput, ServerlessApplicationRepositoryClientResolvedConfig> {
    readonly input: ListApplicationDependenciesCommandInput;
    constructor(input: ListApplicationDependenciesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ServerlessApplicationRepositoryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListApplicationDependenciesCommandInput, ListApplicationDependenciesCommandOutput>;
    private serialize;
    private deserialize;
}
