import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ListApplicationVersionsRequest, ListApplicationVersionsResponse } from "../models/models_0";
import { ServerlessApplicationRepositoryClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ServerlessApplicationRepositoryClient";
export interface ListApplicationVersionsCommandInput extends ListApplicationVersionsRequest {
}
export interface ListApplicationVersionsCommandOutput extends ListApplicationVersionsResponse, __MetadataBearer {
}

export declare class ListApplicationVersionsCommand extends $Command<ListApplicationVersionsCommandInput, ListApplicationVersionsCommandOutput, ServerlessApplicationRepositoryClientResolvedConfig> {
    readonly input: ListApplicationVersionsCommandInput;
    constructor(input: ListApplicationVersionsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ServerlessApplicationRepositoryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListApplicationVersionsCommandInput, ListApplicationVersionsCommandOutput>;
    private serialize;
    private deserialize;
}
