import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { PutApplicationPolicyRequest, PutApplicationPolicyResponse } from "../models/models_0";
import { ServerlessApplicationRepositoryClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ServerlessApplicationRepositoryClient";
export interface PutApplicationPolicyCommandInput extends PutApplicationPolicyRequest {
}
export interface PutApplicationPolicyCommandOutput extends PutApplicationPolicyResponse, __MetadataBearer {
}

export declare class PutApplicationPolicyCommand extends $Command<PutApplicationPolicyCommandInput, PutApplicationPolicyCommandOutput, ServerlessApplicationRepositoryClientResolvedConfig> {
    readonly input: PutApplicationPolicyCommandInput;
    constructor(input: PutApplicationPolicyCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ServerlessApplicationRepositoryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<PutApplicationPolicyCommandInput, PutApplicationPolicyCommandOutput>;
    private serialize;
    private deserialize;
}
