import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { UnshareApplicationRequest } from "../models/models_0";
import { ServerlessApplicationRepositoryClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ServerlessApplicationRepositoryClient";
export interface UnshareApplicationCommandInput extends UnshareApplicationRequest {
}
export interface UnshareApplicationCommandOutput extends __MetadataBearer {
}

export declare class UnshareApplicationCommand extends $Command<UnshareApplicationCommandInput, UnshareApplicationCommandOutput, ServerlessApplicationRepositoryClientResolvedConfig> {
    readonly input: UnshareApplicationCommandInput;
    constructor(input: UnshareApplicationCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ServerlessApplicationRepositoryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UnshareApplicationCommandInput, UnshareApplicationCommandOutput>;
    private serialize;
    private deserialize;
}
